//
//  ViewController.m
//  Demo
//
//  Created by Scott on 2016/10/10.
//  Copyright © 2016年 Scott. All rights reserved.
//

#import "ViewController.h"
#import "MyCollectionViewCell.h"

@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UITableViewDelegate,UITableViewDataSource,UIGestureRecognizerDelegate>
@property (nonatomic,strong)UICollectionView *collectionView;
@property (nonatomic,strong)UITableView      *tableView;

@property (nonatomic,strong)NSString         *deleteItem;

@property (nonatomic,assign)BOOL              isChangeed;
/**
 tableView DataSource
 */
@property (nonatomic,strong)NSMutableArray   *tDataSource;

/**
 CollectionView DataSource
 */
@property (nonatomic,strong)NSMutableArray   *dataSource;


@property (nonatomic,strong) NSIndexPath *indexPath;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    
    [self createCollectionView];
    [self createTableView];
    
}
- (void)createTableView{
    
    _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 140, self.view.bounds.size.width, self.view.bounds.size.height - 140)];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    _tableView.layer.zPosition = 1000;
    [self.view addSubview:_tableView];
    
    _tDataSource = [[NSMutableArray alloc] init];
}
- (void)createCollectionView{
    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
    layout.itemSize = CGSizeMake(50, 50);
    layout.minimumLineSpacing = 10;
    layout.minimumInteritemSpacing = 10;
    layout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
    
    _collectionView = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 140) collectionViewLayout:layout];
    _collectionView.scrollEnabled = NO;
    _collectionView.layer.masksToBounds = NO;
    _collectionView.layer.zPosition = 2000;
    _collectionView.backgroundColor = [[UIColor redColor] colorWithAlphaComponent:0.8];
    _collectionView.dataSource = self;
    _collectionView.delegate = self;
    [_collectionView registerClass:[MyCollectionViewCell class] forCellWithReuseIdentifier:@"cell"];
    
    [self.view addSubview:_collectionView];
    
    UILongPressGestureRecognizer *longGesture = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handlelongGesture:)];
    longGesture.delegate = self;
    [_collectionView addGestureRecognizer:longGesture];
    
    //    _tDataSource = [[NSMutableArray alloc] init];
    
    _dataSource = [NSMutableArray array];
    for (int i = 1; i <= 10; i++) {
        NSString *titleStr = [NSString stringWithFormat:@"%d",i];
        [_dataSource addObject:titleStr];
    }
    [_collectionView reloadData];
}
#pragma mark - UICollectionView
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView{
    return 1;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    
    return _dataSource.count;
    
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    
    MyCollectionViewCell * cell  = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath];
    NSLog(@"--------------%@",_dataSource[indexPath.item]);
    cell.titleLab.text = _dataSource[indexPath.item];
    
    return cell;
    
}
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    NSString    *itemStr = _dataSource[indexPath.item];
    [_dataSource removeObject:itemStr];
    [_tDataSource addObject:itemStr];
    
    [_collectionView reloadData];
    [_tableView reloadData];
    
}

- (void)handlelongGesture:(UILongPressGestureRecognizer *)longGesture {
    
    
    CGPoint point = [longGesture locationInView:self.view];
    //    NSLog(@"中心点%@",NSStringFromCGPoint(point));
    
    
    switch (longGesture.state) {
        case UIGestureRecognizerStateBegan:{
            
            NSIndexPath *indexPath = [self.collectionView indexPathForItemAtPoint:[longGesture locationInView:self.collectionView]];
            if (indexPath == nil) {
                break;
            }
            //            _indexPath = indexPath;
            _deleteItem = _dataSource[indexPath.item];
            
            [self.collectionView beginInteractiveMovementForItemAtIndexPath:indexPath];
        }
            break;
        case UIGestureRecognizerStateChanged:
        {
            //            NSIndexPath *indexPath = [self.collectionView indexPathForItemAtPoint:[longGesture locationInView:self.collectionView]];
            //            if (indexPath == nil) {
            //                _isChangeed = NO;
            //
            //            }else{
            //                _isChangeed = YES;
            //
            //            }
            
            
            [self.collectionView updateInteractiveMovementTargetPosition:[longGesture locationInView:self.collectionView]];
        }
            
            break;
        case UIGestureRecognizerStateEnded:
            [self.collectionView endInteractiveMovement];
            if (point.y > 150) {
                //                [self.collectionView endInteractiveMovement];
                //                if (_isChangeed == NO) {
                
                [_dataSource removeObject:_deleteItem];
                [_tDataSource addObject:_deleteItem];
                NSLog(@"删除后的数据源%@",_dataSource);
                [_collectionView reloadSections:[NSIndexSet indexSetWithIndex:0]];
                [_tableView reloadData];
                //                }
                
            }else{
                //                [self.collectionView endInteractiveMovement];
            }
            
            NSLog(@"%@",_dataSource);
            //            for (int i =0; i <3; i ++) {
            //                   [_collectionView reloadData];
            //            }
            
            break;
        default:
            NSLog(@"啥时候走");
            [self.collectionView cancelInteractiveMovement];
            break;
    }
}

- (BOOL)collectionView:(UICollectionView *)collectionView canMoveItemAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}

- (void)collectionView:(UICollectionView *)collectionView moveItemAtIndexPath:(NSIndexPath *)sourceIndexPath toIndexPath:(NSIndexPath*)destinationIndexPath {
    
    NSLog(@"%@",destinationIndexPath);
    id objc = [_dataSource objectAtIndex:sourceIndexPath.item];
    //从资源数组中移除该数据
    [_dataSource removeObject:objc];
    //将数据插入到资源数组中的目标位置上
    [_dataSource insertObject:objc atIndex:destinationIndexPath.item];
    //    [_collectionView reloadData];
    
}
#pragma mark - UITableView
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _tDataSource.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"tableViewCell"];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"tableViewCell"];
    }
    cell.textLabel.text = _tDataSource[indexPath.row];
    
    return cell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //    [tableView selectRowAtIndexPath:indexPath animated:YES scrollPosition:UITableViewScrollPositionNone];
    
    NSString    *itemStr = _tDataSource[indexPath.row];
    [_tDataSource removeObjectAtIndex:indexPath.row];
    [_dataSource addObject:itemStr];
    
    [_collectionView reloadData];
    [_tableView reloadData];
    
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
